local Util = import('/lua/modules/utilities.lua')
local oldUnit = QuantumGateUnit
QuantumGateUnit = Class(oldUnit) {

	OnStopBeingBuilt = function(self,builder,layer)
		oldUnit.OnStopBeingBuilt(self,builder,layer)
 		self:ForkThread(ButtonThread, self)
		self:ForkThread(GateEffectChecker, self)
	end,
	
    CheckBuildRestriction = function(self, target_bp)
        if self:CanBuild(target_bp.BlueprintId) and not self.Teleporting == true then
            return true
        else
            return false
        end
    end,
	
}
function GateEffectChecker(self)
	self.unitcount = 0
	self.Teleporting = false
	self.UnitsTeleported = {}
	self.teleporters = {}
	self.Sender = false
	self.Reciever = false
	self.FeedbackPulse = false
	local aiBrain = self:GetAIBrain()
	while true do
		#LOG(self.FeedbackPulse)
		#LOG(self.unitcount)
		#LOG(self:IsIdleState())
		if self.unitcount > 0 and self.Teleporting == false and self.FeedbackPulse == false then
			if self.Sender == true then
				ChangeState(self, self.TeleportSendState)
			end
			if self.Reciever == true then
    			ChangeState(self, self.TeleportRecieveState)
    		end
		end
		if self.unitcount == 0 and self.Teleporting == true or self.FeedbackPulse == true and self.Teleporting == true then
       		if self.Sender == true and self:IsIdleState() == true or self.FeedbackPulse == true then
       			#LOG('not sending any units, shutting down')
       			self.Teleporting = false
				self:PlayCloseFlashes()
        		self:CleanupSendEffectsBag()
        		self.Sender = false
        		if not self:IsDead() then
        		    self:SetBusy(false)
       				ChangeState(self, self.IdleState)
       			end
       		end
			if self.Reciever == true and table.getn(self.teleporters) == 0 or self.FeedbackPulse == true then
				#LOG('not recieving any units, shutting down')
				self.Teleporting = false
				self:PlayCloseFlashes()
				self:CleanupRecieveEffectsBag()
				self.Reciever = false
				if not self:IsDead() then
					self:SetBusy(false)
					ChangeState(self, self.IdleState)
       			end
       		end
		end
		if (self:GetHealth() / self:GetMaxHealth()) < 0.75 then
		    local hp = self:GetHealth()
            local maxhp = self:GetMaxHealth()
            local var = ( (hp/maxhp) * (hp/maxhp) *10000 ) / 7.7
			local chance1 = math.random(1,var)
			local chance2 = math.random(1,var)
			if chance1 == chance2 and self.Teleporting == true then
				#LOG('ohno , disaster')
				self:OnKilled()
			end
		end
		WaitTicks(1)
	end
end

function ButtonThread(self)
	self:SetScriptBit('RULEUCC_SpecialToggle', true)
	local aiBrain = self:GetAIBrain()
	while true and not self:IsDead() do
		if self:HasValidTeleportDest() == true and self:GetScriptBit('RULEUCC_SpecialToggle') == false and not self.Reciever == true  then
			self.TeleportDest = true
			#LOG(self.TeleportDest)
		else
			self.TeleportDest = false
			#LOG(self.TeleportDest)
		end
		if self:GetScriptBit('RULEUCC_SpecialToggle') == false and self.TeleportDest == true then
			#LOG('looking for units')
			local rallypos = self:GetRallyPoint()
			local unitstoteleport = aiBrain:GetUnitsAroundPoint('Ally', categories.MOBILE, rallypos, 10)
			for k, v in unitstoteleport do
				if v:IsIdleState() == true and not v.BeingTeleported then
					#LOG('Gate r stealing ur units!!ohno')
					IssueTransportLoad( {v}, self)
				end
			end
		end
		WaitTicks(1)
	end
end
